﻿package {
	import flash.display.MovieClip;
	import flash.geom.ColorTransform;

	public class Effects {

		// Set color and intensity. Defaults to white!
		public function color( dot:MovieClip, tick:Number, x:Number, y:Number, amount:Number, params:Object ) {
			var colTrans:ColorTransform = new ColorTransform();
			var base:Number = 255 * (1-params.intensity);
			colTrans.color = 
				( params.r * params.intensity + base ) << 16 | 
				( params.g * params.intensity + base ) << 8 | 
				( params.b * params.intensity + base );
			dot.transform.colorTransform = colTrans;
		}

		// Scale by params.factor or absolute params.value
		public function scale( dot:MovieClip, tick:Number, x:Number, y:Number, amount:Number, params:Object ) {
			var size = 0;
			if( params.factor ) {
				size = Math.abs( dot.scaleX * params.factor * amount );
			} else {
				size = Math.abs( params.value * amount );
			}
			// Ok, now this sucks. Flash seems to have some kind of converting problem with 
			// very small floating point numbers on OSX and Linux. Small numbers are therefore 
			// capped to avoid shitstorms.
			dot.scaleX = dot.scaleY = size > 0.01 ? size : 0;
		}
		
		// Cheesy plasma effect, based on position (x,y) and tick
		public function plasma( dot:MovieClip, tick:Number, x:Number, y:Number, amount:Number, params:Object ) {
			var yt1:Number = Math.cos( y * 0.25 + tick * 0.5 );
			var yt2:Number = Math.cos( y * 0.5 - tick * 0.75 );
			var xt1:Number = Math.cos( x * 0.25 - tick * 0.5 );
			var xc1:Number = Math.cos( x * 0.66 + yt1 * 2 );
			var yc1:Number = Math.cos( y * 0.5 - xt1 *2 );

			var s:Number = ( yt1 + yt2 + xt1 + xc1 + yc1 ) / 5;
			this.scale( dot, tick, x, y, amount, { 'value': s } );
		}
	}
}